<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: main.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<h1>main.c</h1><a href="main_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: main.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef PYTHON</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#include &quot;Python.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#endif</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init/init.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg/llg.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="preprocessor">#ifdef TAO</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="emini_8h.html">emini/emini.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#endif</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;llgts/llgts.h&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;llg2/llg2.h&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;brown/brown.h&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor">#endif</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>
<a name="l00052"></a>00052 <span class="preprocessor">#ifdef EBM</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#include &quot;ebm/ebm.h&quot;</span>
<a name="l00054"></a>00054 <span class="preprocessor">#endif</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00056"></a>00056 <span class="comment">/* prototype for function Solve below */</span>
<a name="l00057"></a>00057 <span class="keywordtype">int</span> <a class="code" href="main_8c.html#af91d94707b6b88920418dfb69be0e106">Solve</a>(<a class="code" href="structGridData.html">GridData</a> *gdata);
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="main_8c.html#a7a29781a20c5dd4153c3c1cecf0ff328">00059</a> <span class="keywordtype">int</span> <a class="code" href="main_8c.html#a7a29781a20c5dd4153c3c1cecf0ff328">main</a>(<span class="keywordtype">int</span> argc,<span class="keywordtype">char</span> **args)
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   <span class="keywordtype">int</span> ierr;
<a name="l00062"></a>00062   <a class="code" href="structGridData.html">GridData</a> gdata;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   ierr = PetscInitialize(
<a name="l00065"></a>00065     &amp;argc,&amp;args,
<a name="l00066"></a>00066     <span class="stringliteral">&quot;allopt.txt&quot;</span>,
<a name="l00067"></a>00067     <span class="stringliteral">&quot;magpar - parallel micromagnetics package\n&quot;</span>
<a name="l00068"></a>00068   );CHKERRQ(ierr);
<a name="l00069"></a>00069 <span class="preprocessor">#ifdef TAO</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>  TaoInitialize(&amp;argc,&amp;args,(<span class="keywordtype">char</span> *)0,<span class="stringliteral">&quot;magpar - parallel micromagnetics package\n&quot;</span>);
<a name="l00071"></a>00071 <span class="preprocessor">#endif</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>
<a name="l00073"></a>00073 <span class="preprocessor">#ifdef PYTHON</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>  Py_Initialize();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">/* import python script/module */</span>
<a name="l00077"></a>00077 <span class="preprocessor">#define NEWPYTHONIMPORT</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span><span class="preprocessor">#ifdef NEWPYTHONIMPORT</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>  gdata.pModule = PyImport_ImportModule(MAGPARSTDPYTHONMOD); <span class="comment">/* new reference */</span>
<a name="l00080"></a>00080 <span class="preprocessor">#else</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>  PyObject *pName;
<a name="l00082"></a>00082   pName = PyString_FromString(MAGPARSTDPYTHONMOD); <span class="comment">/* new reference */</span>
<a name="l00083"></a>00083   gdata.pModule = PyImport_Import(pName);          <span class="comment">/* new reference */</span>
<a name="l00084"></a>00084 <span class="preprocessor">#endif</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span>  <span class="keywordflow">if</span>(!gdata.pModule) {
<a name="l00086"></a>00086     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Could not import Python module %s.py. The module file needs to be in PYTHONPATH!\n&quot;</span>,MAGPARSTDPYTHONMOD);
<a name="l00087"></a>00087   }
<a name="l00088"></a>00088   <span class="keywordflow">else</span> {
<a name="l00089"></a>00089     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Imported Python module %s.py.\n&quot;</span>,MAGPARSTDPYTHONMOD);
<a name="l00090"></a>00090   }
<a name="l00091"></a>00091 <span class="preprocessor">#endif</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>
<a name="l00093"></a>00093   PetscLogDouble t_t1,t_t2;
<a name="l00094"></a>00094   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;&gt;&gt; %s::%s\n&quot;</span>,__FILE__,<a class="code" href="griddata_8h.html#ae60511a9aa5cbf216a00a1bb81006bc5">__FUNCT__</a>);
<a name="l00095"></a>00095   PetscGetTime(&amp;t_t1);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00098"></a>00098     <span class="stringliteral">&quot;\nmagpar is distributed under the terms of the GNU General Public License\n&quot;</span>
<a name="l00099"></a>00099     <span class="stringliteral">&quot;Copyright (C) 2002-2010 Werner Scholz\n&quot;</span>
<a name="l00100"></a>00100   );
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="preprocessor">#include &quot;<a class="code" href="magpar__version_8h.html">magpar_version.h</a>&quot;</span>
<a name="l00103"></a>00103 <span class="preprocessor">#include &quot;<a class="code" href="magpar__revision_8h.html">magpar_revision.h</a>&quot;</span>
<a name="l00104"></a>00104   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00105"></a>00105     <span class="stringliteral">&quot;--------------------------------------------------------------------------\n\n&quot;</span>
<a name="l00106"></a>00106     <span class="stringliteral">&quot;magpar version %s build %s\n&quot;</span>,
<a name="l00107"></a>00107     <a class="code" href="magpar__version_8h.html#afd75f69a3b24674844feb22458a7ce51">MAGPAR_VERSION</a>,<a class="code" href="magpar__revision_8h.html#ac5e8c4ae3555cb01bbb14f878cc4a580">MAGPAR_REVISION</a>
<a name="l00108"></a>00108   );
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">/* Turns on debugging for the memory management routines.</span>
<a name="l00111"></a>00111 <span class="comment">     CHKMEMQ calls below:</span>
<a name="l00112"></a>00112 <span class="comment">     Checks the memory for corruption, calls error handler if any is detected.</span>
<a name="l00113"></a>00113 <span class="comment">  */</span>
<a name="l00114"></a>00114   ierr = PetscMallocDebug(PETSC_TRUE);CHKERRQ(ierr);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   ierr = <a class="code" href="init_8h.html#ae4c8f3120a177cfe3ce6929927865a94">SerInit</a>(&amp;gdata);CHKERRQ(ierr);CHKMEMQ;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   ierr = <a class="code" href="init_8h.html#aab78598aa0d3ece1097d988997f0aea3">ParInit</a>(&amp;gdata);CHKERRQ(ierr);CHKMEMQ;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">/* Turns off debugging for the memory management routines. */</span>
<a name="l00121"></a>00121   ierr = PetscMallocDebug(PETSC_FALSE);CHKERRQ(ierr);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   ierr = <a class="code" href="main_8c.html#af91d94707b6b88920418dfb69be0e106">Solve</a>(&amp;gdata);CHKERRQ(ierr);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   PetscGetTime(&amp;t_t2);
<a name="l00126"></a>00126   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00127"></a>00127     <span class="stringliteral">&quot;&lt;&lt; %s::%s took %g s = %g h\n&quot;</span>,
<a name="l00128"></a>00128     __FILE__,<a class="code" href="griddata_8h.html#ae60511a9aa5cbf216a00a1bb81006bc5">__FUNCT__</a>,t_t2-t_t1,(t_t2-t_t1)/3600
<a name="l00129"></a>00129   );
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#ifdef PYTHON</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span><span class="preprocessor">#ifndef NEWPYTHONIMPORT</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>  Py_DECREF(pName);
<a name="l00134"></a>00134 <span class="preprocessor">#endif</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (gdata.pModule) {
<a name="l00136"></a>00136     Py_DECREF(gdata.pModule);
<a name="l00137"></a>00137   }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   Py_Finalize();
<a name="l00140"></a>00140 <span class="preprocessor">#endif</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00142"></a>00142   PetscFinalize();
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a><a class="code" href="main_8c.html#ae4f2eb4a1c11c65d9a480b992675dcf9">00146</a> <span class="keywordtype">int</span> <a class="code" href="main_8c.html#ae4f2eb4a1c11c65d9a480b992675dcf9">keepsolving</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00147"></a>00147 {
<a name="l00148"></a>00148   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">/* initialize upon first call */</span>
<a name="l00151"></a>00151   <span class="keyword">static</span> PetscReal jfinal=PETSC_MIN;
<a name="l00152"></a>00152   <span class="keyword">static</span> PetscReal mfinal[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>]={PETSC_MIN,PETSC_MIN,PETSC_MIN};
<a name="l00153"></a>00153   <span class="keyword">static</span> PetscReal tstop=PETSC_MIN;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>  <span class="comment">/* single precision needs a cast</span>
<a name="l00157"></a>00157 <span class="comment">     there seems to be an issue with the definition of PETSC_MIN and single precision</span>
<a name="l00158"></a>00158 <span class="comment">  */</span>
<a name="l00159"></a>00159   <span class="keywordflow">if</span> (jfinal==(PetscReal)PETSC_MIN) {
<a name="l00160"></a>00160 <span class="preprocessor">#else</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (jfinal==PETSC_MIN) {
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>    PetscTruth flg;
<a name="l00164"></a>00164     ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-jfinal&quot;</span>,&amp;jfinal,&amp;flg);CHKERRQ(ierr);
<a name="l00165"></a>00165     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00166"></a>00166       jfinal=-0.95;
<a name="l00167"></a>00167       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00168"></a>00168         <span class="stringliteral">&quot;Option -jfinal not found, using default value: %g\n&quot;</span>,
<a name="l00169"></a>00169         jfinal
<a name="l00170"></a>00170       );
<a name="l00171"></a>00171     }
<a name="l00172"></a>00172     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;jfinal: %g (1)\n&quot;</span>,jfinal);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     <span class="keywordtype">int</span> nmax = <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00175"></a>00175     ierr = PetscOptionsGetRealArray(PETSC_NULL,<span class="stringliteral">&quot;-mfinal&quot;</span>,mfinal,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00178"></a>00178       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00179"></a>00179         <span class="stringliteral">&quot;Option -mfinal not found, using default value: %g,%g,%g\n&quot;</span>,
<a name="l00180"></a>00180         mfinal[0],mfinal[1],mfinal[2]
<a name="l00181"></a>00181       );
<a name="l00182"></a>00182       nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184     <span class="keywordflow">if</span> (nmax!=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>){
<a name="l00185"></a>00185       SETERRQ(PETSC_ERR_ARG_INCOMP,
<a name="l00186"></a>00186         <span class="stringliteral">&quot;Wrong number of values for option -mfinal!\n&quot;</span>);
<a name="l00187"></a>00187     }
<a name="l00188"></a>00188     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;mfinal: %g,%g,%g (1)\n&quot;</span>,mfinal[0],mfinal[1],mfinal[2]);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190     ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-ts_max_time&quot;</span>,&amp;tstop,&amp;flg);CHKERRQ(ierr);
<a name="l00191"></a>00191     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00192"></a>00192       <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==0 || gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==2 || gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==3) {
<a name="l00193"></a>00193         tstop=5;
<a name="l00194"></a>00194       }
<a name="l00195"></a>00195       <span class="keywordflow">else</span> {
<a name="l00196"></a>00196         tstop=PETSC_MAX;
<a name="l00197"></a>00197       }
<a name="l00198"></a>00198       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00199"></a>00199         <span class="stringliteral">&quot;Option -ts_max_time not found, using default value: %g\n&quot;</span>,
<a name="l00200"></a>00200         tstop
<a name="l00201"></a>00201       );
<a name="l00202"></a>00202     }
<a name="l00203"></a>00203     tstop /= 1e9*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>;
<a name="l00204"></a>00204     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;reduced end time: %g (1)\n&quot;</span>,tstop);
<a name="l00205"></a>00205   }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="comment">/* write inp file regularly (for easy restart):</span>
<a name="l00209"></a>00209 <span class="comment">     check if 2000 s (=33 min) have passed since last checkpoint file</span>
<a name="l00210"></a>00210 <span class="comment">     and set flag</span>
<a name="l00211"></a>00211 <span class="comment">  */</span>
<a name="l00212"></a>00212   <span class="keywordtype">int</span> checkpoint=0;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="keyword">static</span> PetscLogDouble inp_last_CPUt=PETSC_MIN;
<a name="l00215"></a>00215   ierr = PetscGetTime(&amp;t_t2);CHKERRQ(ierr);
<a name="l00216"></a>00216   <span class="keywordflow">if</span> (t_t2-inp_last_CPUt &gt; 2000.0) {
<a name="l00217"></a>00217     checkpoint=1;
<a name="l00218"></a>00218   }
<a name="l00219"></a>00219   <span class="comment">/* broadcast the flag from the first processor to all others;</span>
<a name="l00220"></a>00220 <span class="comment">     this is necessary because each processors gets a slightly different</span>
<a name="l00221"></a>00221 <span class="comment">     result and they they might part ways here and hang</span>
<a name="l00222"></a>00222 <span class="comment">  */</span>
<a name="l00223"></a>00223   ierr = MPI_Bcast(&amp;checkpoint,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="comment">/* write checkpoint file if necessary */</span>
<a name="l00226"></a>00226   <span class="keywordflow">if</span> (checkpoint) {
<a name="l00227"></a>00227     <span class="keywordtype">int</span>  oldinp;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229     oldinp=gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>;
<a name="l00230"></a>00230     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=9999;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     <span class="comment">/* is t_t2 an int? */</span>
<a name="l00233"></a>00233     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00234"></a>00234       <span class="stringliteral">&quot;Writing checkpoint file (9999) at: %g ns\n&quot;</span>,
<a name="l00235"></a>00235       gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9
<a name="l00236"></a>00236     );
<a name="l00237"></a>00237     ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
<a name="l00238"></a>00238 
<a name="l00239"></a>00239     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=oldinp;
<a name="l00240"></a>00240     inp_last_CPUt=t_t2;
<a name="l00241"></a>00241 
<a name="l00242"></a>00242     checkpoint=0;
<a name="l00243"></a>00243   }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <span class="keywordtype">int</span> exitcode=1;   <span class="comment">/* by default return true */</span>
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   PetscReal valMpHext;
<a name="l00248"></a>00248   ierr = <a class="code" href="field_8h.html#aacac4af746c003dbd608d662ca2272e2">MpHext</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;valMpHext);CHKERRQ(ierr);
<a name="l00249"></a>00249   <span class="keywordflow">if</span> (valMpHext &lt; jfinal) {
<a name="l00250"></a>00250     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00251"></a>00251       <span class="stringliteral">&quot;J//Hext %g &lt;= jfinal %g\n&quot;</span>,
<a name="l00252"></a>00252       valMpHext,jfinal
<a name="l00253"></a>00253     );
<a name="l00254"></a>00254     exitcode=0;
<a name="l00255"></a>00255   }
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   PetscReal Mtot[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00258"></a>00258   ierr = <a class="code" href="magpario_8h.html#acf315ef77c9cda0a419e75748c5ad9a8">Vec3VolAvg</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,Mtot);CHKERRQ(ierr);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;i++) {
<a name="l00261"></a>00261     <span class="keywordflow">if</span> (Mtot[i] &lt; mfinal[i]) {
<a name="l00262"></a>00262       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00263"></a>00263         <span class="stringliteral">&quot;M_%i %g &lt;= mfinal\n&quot;</span>,
<a name="l00264"></a>00264         i,Mtot[i]
<a name="l00265"></a>00265       );
<a name="l00266"></a>00266       exitcode=0;
<a name="l00267"></a>00267     }
<a name="l00268"></a>00268   }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a> &gt; tstop) {
<a name="l00271"></a>00271     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00272"></a>00272       <span class="stringliteral">&quot;gdata-&gt;time %g ns &gt;= tstop %g ns\n&quot;</span>,
<a name="l00273"></a>00273       gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9,tstop*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9
<a name="l00274"></a>00274     );
<a name="l00275"></a>00275     exitcode=0;
<a name="l00276"></a>00276   }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">/* broadcast exit signal to all processors */</span>
<a name="l00279"></a>00279   ierr = MPI_Bcast(&amp;gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(exitcode);
<a name="l00282"></a>00282 }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a><a class="code" href="main_8c.html#af91d94707b6b88920418dfb69be0e106">00285</a> <span class="keywordtype">int</span> <a class="code" href="main_8c.html#af91d94707b6b88920418dfb69be0e106">Solve</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00286"></a>00286 {
<a name="l00287"></a>00287   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00290"></a>00290     <span class="stringliteral">&quot;--------------------------------------------------------------------------\n&quot;</span>
<a name="l00291"></a>00291     <span class="stringliteral">&quot;Entering solution loop\n\n&quot;</span>
<a name="l00292"></a>00292   );
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="keywordflow">while</span> (<a class="code" href="main_8c.html#ae4f2eb4a1c11c65d9a480b992675dcf9">keepsolving</a>(gdata) &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=99) {
<a name="l00295"></a>00295     <span class="keywordflow">switch</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>) {
<a name="l00296"></a>00296       <span class="keywordflow">case</span> 0:
<a name="l00297"></a>00297 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00298"></a>00298 <span class="preprocessor"></span>        ierr = <a class="code" href="mytssteppvode_8c.html#a61c49a5366b0ae16513998a657704e37">myTSStepPVode</a>(gdata);CHKERRQ(ierr);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300         <span class="comment">/* necessary to recalculate Htot, Energy ? */</span>
<a name="l00301"></a>00301         <span class="comment">/* does not seem so (compared .log files with and without these calls)</span>
<a name="l00302"></a>00302 <span class="comment">           error is sometimes in the last digit</span>
<a name="l00303"></a>00303 <span class="comment">           skip it - saves time!</span>
<a name="l00304"></a>00304 <span class="comment">           further simulation does not depend on it anyway,</span>
<a name="l00305"></a>00305 <span class="comment">           only output in .log file is a little inaccurate</span>
<a name="l00306"></a>00306 <span class="comment"></span>
<a name="l00307"></a>00307 <span class="comment">        ierr = Htot(gdata);CHKERRQ(ierr);</span>
<a name="l00308"></a>00308 <span class="comment">        */</span>
<a name="l00309"></a>00309 
<a name="l00310"></a>00310         ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00311"></a>00311         ierr = <a class="code" href="checkiterationllg_8c.html#a5433821a82b3ad3af34bb43677541a33">CheckIterationLLG</a>(gdata);CHKERRQ(ierr);
<a name="l00312"></a>00312 <span class="preprocessor">#endif</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>      <span class="keywordflow">break</span>;
<a name="l00314"></a>00314       <span class="keywordflow">case</span> 1:
<a name="l00315"></a>00315 <span class="preprocessor">#ifdef TAO</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>        ierr = <a class="code" href="eminisolve_8c.html#a17d21e725c11c8a2fade9a2d83d98047">EminiSolve</a>(gdata);CHKERRQ(ierr);
<a name="l00317"></a>00317         ierr = <a class="code" href="checkiterationemini_8c.html#a1c9f3282235f811af60323611535e99b">CheckIterationEmini</a>(gdata);CHKERRQ(ierr);
<a name="l00318"></a>00318 <span class="preprocessor">#if 0</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span>        <span class="comment">/* hack for reader sensitivity function */</span>
<a name="l00320"></a>00320         gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>=1;
<a name="l00321"></a>00321 <span class="preprocessor">#endif</span>
<a name="l00322"></a>00322 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00323"></a>00323 <span class="preprocessor"></span>      <span class="keywordflow">break</span>;
<a name="l00324"></a>00324       <span class="keywordflow">case</span> 2:
<a name="l00325"></a>00325       <span class="keywordflow">case</span> 3:
<a name="l00326"></a>00326 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>        ierr = <a class="code" href="mytssteppvode_8c.html#a61c49a5366b0ae16513998a657704e37">myTSStepPVode</a>(gdata);CHKERRQ(ierr);
<a name="l00328"></a>00328         ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00329"></a>00329         ierr = <a class="code" href="checkiterationllg_8c.html#a5433821a82b3ad3af34bb43677541a33">CheckIterationLLG</a>(gdata);CHKERRQ(ierr);
<a name="l00330"></a>00330 <span class="preprocessor">#endif</span>
<a name="l00331"></a>00331 <span class="preprocessor"></span>      <span class="keywordflow">break</span>;
<a name="l00332"></a>00332 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>      <span class="keywordflow">case</span> 4:
<a name="l00334"></a>00334         ierr = myTSStep2(gdata);CHKERRQ(ierr);
<a name="l00335"></a>00335         ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00336"></a>00336         ierr = CheckIterationLLG2(gdata);CHKERRQ(ierr);
<a name="l00337"></a>00337       <span class="keywordflow">break</span>;
<a name="l00338"></a>00338 <span class="preprocessor">#endif</span>
<a name="l00339"></a>00339 <span class="preprocessor"></span><span class="preprocessor">#ifdef EBM</span>
<a name="l00340"></a>00340 <span class="preprocessor"></span>      <span class="keywordflow">case</span> 50:
<a name="l00341"></a>00341         ierr = myTSStepPVodeEBM(gdata);CHKERRQ(ierr);
<a name="l00342"></a>00342         ierr = CheckIterationEBM(gdata);CHKERRQ(ierr);
<a name="l00343"></a>00343         gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>=0;
<a name="l00344"></a>00344       <span class="keywordflow">break</span>;
<a name="l00345"></a>00345 <span class="preprocessor">#endif</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span><span class="preprocessor">#ifdef ADDONS</span>
<a name="l00347"></a>00347 <span class="preprocessor"></span>      <span class="keywordflow">case</span> 51:
<a name="l00348"></a>00348         ierr = myTSStep(gdata);CHKERRQ(ierr);
<a name="l00349"></a>00349         ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00350"></a>00350         ierr = CheckIterationLLGTS(gdata);CHKERRQ(ierr);
<a name="l00351"></a>00351       <span class="keywordflow">break</span>;
<a name="l00352"></a>00352       <span class="keywordflow">case</span> 52:
<a name="l00353"></a>00353         ierr = BrownSolve(gdata);CHKERRQ(ierr);
<a name="l00354"></a>00354       <span class="keywordflow">break</span>;
<a name="l00355"></a>00355       <span class="keywordflow">case</span> 53:
<a name="l00356"></a>00356 <span class="preprocessor">#ifdef TAO</span>
<a name="l00357"></a>00357 <span class="preprocessor"></span>        ierr = <a class="code" href="eminisolve_8c.html#a17d21e725c11c8a2fade9a2d83d98047">EminiSolve</a>(gdata);CHKERRQ(ierr);
<a name="l00358"></a>00358         ierr = <a class="code" href="checkiterationemini_8c.html#a1c9f3282235f811af60323611535e99b">CheckIterationEmini</a>(gdata);CHKERRQ(ierr);
<a name="l00359"></a>00359 <span class="preprocessor">#endif</span>
<a name="l00360"></a>00360 <span class="preprocessor"></span>      <span class="keywordflow">break</span>;
<a name="l00361"></a>00361 <span class="preprocessor">#endif</span>
<a name="l00362"></a>00362 <span class="preprocessor"></span>      <span class="keywordflow">default</span>:
<a name="l00363"></a>00363         SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;Unknown mode selected! Exiting!\n&quot;</span>);
<a name="l00364"></a>00364       <span class="keywordflow">break</span>;
<a name="l00365"></a>00365     }
<a name="l00366"></a>00366   }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   PetscGetTime(&amp;t_t2);
<a name="l00369"></a>00369   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00370"></a>00370     <span class="stringliteral">&quot;--------------------------------------------------------------------------\n&quot;</span>
<a name="l00371"></a>00371     <span class="stringliteral">&quot;Finished solution loop in %g s = %g h\n\n&quot;</span>,
<a name="l00372"></a>00372     t_t2-t_t1,(t_t2-t_t1)/3600
<a name="l00373"></a>00373   );
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <span class="comment">/* make sure that we save the final state</span>
<a name="l00376"></a>00376 <span class="comment">     this way we have a duplicate of the last log line</span>
<a name="l00377"></a>00377 <span class="comment">     but otherwise we would miss the inp number in the log file</span>
<a name="l00378"></a>00378 <span class="comment">  */</span>
<a name="l00379"></a>00379   gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00380"></a>00380   ierr = <a class="code" href="magpario_8h.html#ad970cf1663bac1ede525a5caf43750fd">WriteLog</a>(gdata);CHKERRQ(ierr);
<a name="l00381"></a>00381   ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00384"></a>00384 }
<a name="l00385"></a>00385 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

